# -*- coding: utf-8 -*-

"""
shellsmartpayapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from shellsmartpayapi.api_helper import APIHelper
from shellsmartpayapi.configuration import Server
from shellsmartpayapi.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from shellsmartpayapi.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from shellsmartpayapi.models.payment_enablement_response import PaymentEnablementResponse
from shellsmartpayapi.exceptions.payment_enablement_error_response_exception import PaymentEnablementErrorResponseException
from shellsmartpayapi.exceptions.api_exception import APIException


class DigitalPaymentEnablementController(BaseController):

    """A Controller to access Endpoints in the shellsmartpayapi API."""
    def __init__(self, config):
        super(DigitalPaymentEnablementController, self).__init__(config)

    def mpay_v_1_tokens_ref_put(self,
                                body):
        """Does a PUT request to /PaymentEnablement/v1/ref.

        Generates a DPAN and stores the relationship between the Reference ID,
        DPAN and the real PAN. This method is called during the customer
        registration process, ahead of any payment. The Reference ID is an
        identifier chosen by the client system for mobile payment
        registration. It must be unique in context of the client system, and
        is the key to obtaining and managing the payment details later.

        Args:
            body (MobilePaymentRegistrationRequest): TODO: type description
                here.

        Returns:
            PaymentEnablementResponse: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.SHELL)
            .path('/PaymentEnablement/v1/ref')
            .http_method(HttpMethodEnum.PUT)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Single('oAuthTokenPost'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(PaymentEnablementResponse.from_dictionary)
            .local_error('400', 'Error Occurred. The server cannot or will not process the request due to an apparent client error (e.g., malformed request syntax, invalid request message).', PaymentEnablementErrorResponseException)
            .local_error('401', 'Unauthorized. The request has not been applied because it lacks valid authentication credentials for the target resource.', APIException)
            .local_error('403', 'Forbidden. The server understood the request but refuses to authorize it.', APIException)
            .local_error('404', 'Not Found. The origin server did not find a current representation for the target resource or is not willing to disclose that one exists.', APIException)
            .local_error('500', 'Internal Server Error. The server encountered an unexpected condition that prevented it from fulfilling the request.', APIException)
        ).execute()
