# -*- coding: utf-8 -*-

"""
shellsmartpayapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellsmartpayapi.api_helper import APIHelper
from shellsmartpayapi.models.loc import Loc
from shellsmartpayapi.models.opening_hour import OpeningHour


class Datum(object):

    """Implementation of the 'Datum' model.

    TODO: type model description here.

    Attributes:
        id (str): The station’s unique site identifier – this must be ignored
        mtype (int): All fuel stations are of at least one Type, indicating
            whether it is Shell-branded or not, and if the station can be used
            by trucks. Note that a station can have more than one Type (e.g.
            Shell retail sites (Type=0) can also be truck friendly (Type=2)). 
            Type values are as follows: *  0 = Shell owned/branded stations
            that are not also Type=2 or Type=3 *  1 = Partner stations
            accepting Shell Card   *  2 = Shell owned/branded stations that
            are truck friendly but not Type=3 *  3 = Shell owned/branded
            stations that are truck only
        name (str): The name of the site
        addr (str): The side address as a concatenation of address information
        lat (float): The site’s latitude
        lon (float): The site’s longitude
        amen (List[int]): An array of amenities available at the station (see
            above for complete list)
        fuel (List[int]): An array of fuels* available at the station.  Global
            Product Group names:  *  8 = CNG  *  10 = Premium Gasoline  *  11
            = Premium Diesel  *  12 = Fuelsave Midgrade Gasoline  *  13 =
            Fuelsave Regular Diesel  *  14 = Midgrade Gasoline  *  15 = Low
            Octane gasoline  *  16 = Regular Diesel  *  17 = Autogas LPG  * 
            18 = Auto/RV Propane  *  20 = Hydrogen  *  21 = Kerosene  *  22 =
            Super Premium Gasoline  *  23 = Unleaded Super  *  24 = Truck
            Diesel  *  25 = Super98  *  26 = GTL  *  27 = Fuelsave 98  *  28 =
            LNG  *  29 = DieselFit  *  30 = Shell Recharge    *An external
            mapping table may need to be maintained if it is required to
            display true fuel product names (as visible on the site)
        loc (Loc): Object containing address details/elements
        mpp_station_id (str): This is the 5-digit Shell Station ID. Leading
            ‘0’ should be dropped and only last four digits, should be used.
            E.G. for ‘00123’, only ‘0123’ should be used and for ‘04567’ only
            ‘4567’ should be used.
        double_site_id (str): The Mobile Payment Platform recognises a user
            being located at a Shell Station if their GPS is within 300m of a
            Shell station. Some locations will return multiple Shell Stations
            within a 300 meter radius. This is an issue for Mobile Payments as
            it needs  to accurately identify the station the Customer is
            located at to ensure the correct pump is released   In Germany
            such locations have been identified and each Station has been
            assigned a unique letter (e.g. A, B, C). These letters are clearly
            visible at the stations. If a Mobile Payments user is located at
            such a location, they will need to identify the Station by
            identifying and specifying the Station’s corresponding letter as
            part of the refuelling journey.   The double_site_id is used to
            store the Stations unique letter/ID value. It’s only populated
            if/when 1 or more stations are within 300m from this station.
        opening_hours (List[OpeningHour]): An Array of the station’s opening
            hours. This may have opening and closing times in hours, minutes
            and the day of the week.
        telephone (str): Station’s contact telephone number
        authorisation_code (str): Station’s authorisation code
        mp_preauth (int): Station’s mobile payment preauthorisation value

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "mtype": 'type',
        "name": 'name',
        "addr": 'addr',
        "lat": 'lat',
        "lon": 'lon',
        "amen": 'amen',
        "fuel": 'fuel',
        "loc": 'loc',
        "mpp_station_id": 'mpp_station_id',
        "double_site_id": 'double_site_id',
        "opening_hours": 'opening_hours',
        "telephone": 'telephone',
        "authorisation_code": 'authorisation_code',
        "mp_preauth": 'mp_preauth'
    }

    _optionals = [
        'id',
        'mtype',
        'name',
        'addr',
        'lat',
        'lon',
        'amen',
        'fuel',
        'loc',
        'mpp_station_id',
        'double_site_id',
        'opening_hours',
        'telephone',
        'authorisation_code',
        'mp_preauth',
    ]

    def __init__(self,
                 id=APIHelper.SKIP,
                 mtype=APIHelper.SKIP,
                 name=APIHelper.SKIP,
                 addr=APIHelper.SKIP,
                 lat=APIHelper.SKIP,
                 lon=APIHelper.SKIP,
                 amen=APIHelper.SKIP,
                 fuel=APIHelper.SKIP,
                 loc=APIHelper.SKIP,
                 mpp_station_id=APIHelper.SKIP,
                 double_site_id=APIHelper.SKIP,
                 opening_hours=APIHelper.SKIP,
                 telephone=APIHelper.SKIP,
                 authorisation_code=APIHelper.SKIP,
                 mp_preauth=APIHelper.SKIP):
        """Constructor for the Datum class"""

        # Initialize members of the class
        if id is not APIHelper.SKIP:
            self.id = id 
        if mtype is not APIHelper.SKIP:
            self.mtype = mtype 
        if name is not APIHelper.SKIP:
            self.name = name 
        if addr is not APIHelper.SKIP:
            self.addr = addr 
        if lat is not APIHelper.SKIP:
            self.lat = lat 
        if lon is not APIHelper.SKIP:
            self.lon = lon 
        if amen is not APIHelper.SKIP:
            self.amen = amen 
        if fuel is not APIHelper.SKIP:
            self.fuel = fuel 
        if loc is not APIHelper.SKIP:
            self.loc = loc 
        if mpp_station_id is not APIHelper.SKIP:
            self.mpp_station_id = mpp_station_id 
        if double_site_id is not APIHelper.SKIP:
            self.double_site_id = double_site_id 
        if opening_hours is not APIHelper.SKIP:
            self.opening_hours = opening_hours 
        if telephone is not APIHelper.SKIP:
            self.telephone = telephone 
        if authorisation_code is not APIHelper.SKIP:
            self.authorisation_code = authorisation_code 
        if mp_preauth is not APIHelper.SKIP:
            self.mp_preauth = mp_preauth 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        id = dictionary.get("id") if dictionary.get("id") else APIHelper.SKIP
        mtype = dictionary.get("type") if dictionary.get("type") else APIHelper.SKIP
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        addr = dictionary.get("addr") if dictionary.get("addr") else APIHelper.SKIP
        lat = dictionary.get("lat") if dictionary.get("lat") else APIHelper.SKIP
        lon = dictionary.get("lon") if dictionary.get("lon") else APIHelper.SKIP
        amen = dictionary.get("amen") if dictionary.get("amen") else APIHelper.SKIP
        fuel = dictionary.get("fuel") if dictionary.get("fuel") else APIHelper.SKIP
        loc = Loc.from_dictionary(dictionary.get('loc')) if 'loc' in dictionary.keys() else APIHelper.SKIP
        mpp_station_id = dictionary.get("mpp_station_id") if dictionary.get("mpp_station_id") else APIHelper.SKIP
        double_site_id = dictionary.get("double_site_id") if dictionary.get("double_site_id") else APIHelper.SKIP
        opening_hours = None
        if dictionary.get('opening_hours') is not None:
            opening_hours = [OpeningHour.from_dictionary(x) for x in dictionary.get('opening_hours')]
        else:
            opening_hours = APIHelper.SKIP
        telephone = dictionary.get("telephone") if dictionary.get("telephone") else APIHelper.SKIP
        authorisation_code = dictionary.get("authorisation_code") if dictionary.get("authorisation_code") else APIHelper.SKIP
        mp_preauth = dictionary.get("mp_preauth") if dictionary.get("mp_preauth") else APIHelper.SKIP
        # Return an object of this model
        return cls(id,
                   mtype,
                   name,
                   addr,
                   lat,
                   lon,
                   amen,
                   fuel,
                   loc,
                   mpp_station_id,
                   double_site_id,
                   opening_hours,
                   telephone,
                   authorisation_code,
                   mp_preauth)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'id={self.id!r}, '
                f'mtype={self.mtype!r}, '
                f'name={self.name!r}, '
                f'addr={self.addr!r}, '
                f'lat={self.lat!r}, '
                f'lon={self.lon!r}, '
                f'amen={self.amen!r}, '
                f'fuel={self.fuel!r}, '
                f'loc={self.loc!r}, '
                f'mpp_station_id={self.mpp_station_id!r}, '
                f'double_site_id={self.double_site_id!r}, '
                f'opening_hours={self.opening_hours!r}, '
                f'telephone={self.telephone!r}, '
                f'authorisation_code={self.authorisation_code!r}, '
                f'mp_preauth={self.mp_preauth!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'id={self.id!s}, '
                f'mtype={self.mtype!s}, '
                f'name={self.name!s}, '
                f'addr={self.addr!s}, '
                f'lat={self.lat!s}, '
                f'lon={self.lon!s}, '
                f'amen={self.amen!s}, '
                f'fuel={self.fuel!s}, '
                f'loc={self.loc!s}, '
                f'mpp_station_id={self.mpp_station_id!s}, '
                f'double_site_id={self.double_site_id!s}, '
                f'opening_hours={self.opening_hours!s}, '
                f'telephone={self.telephone!s}, '
                f'authorisation_code={self.authorisation_code!s}, '
                f'mp_preauth={self.mp_preauth!s})')
